program gr_h01; {        }
{$APPTYPE    CONSOLE}
uses
  Graphics, Classes, SysUtils, jpeg;
const NFormul = 7; { #   }
type
  TInterp = procedure;  { p2 -> p3 }
var mx, my, mx2, my2: integer;
    BitMap : TBitMap;
    jp     : TJpegImage;
    p1, p2, p3: array of array of byte;
    res, resS, resS2 : array[1..NFormul] of extended;
    al, be, ga: extended;
{----------------------------------------------------------------------}
procedure f01; { p2 -> p3:     4   }
var i,j: integer;
begin
   for i:= 0 to mx-1 do
   for j:= 0 to my-1 do
   p3[i,j]:=p2[i div 2,j div 2];
end;
{ ................. }
procedure f02; { p2 -> p3:    }
var i,j: integer;
begin
   for i:= 0 to mx2-1 do
   for j:= 0 to my2-1 do begin
     p3[2*i  ,2*j  ]:=p2[i,j];
     p3[2*i+1,2*j  ]:=(integer(p2[i,j])+ p2[i+1,j]) div 2 ;
     p3[2*i  ,2*j+1]:=(integer(p2[i,j])+ p2[i,j+1]) div 2 ;
     p3[2*i+1,2*j+1]:=(integer(p2[i,j])+ p2[i+1,j]+ p2[i,j+1]+ p2[i+1,j+1]) div 4 ;
   end;
end;
{ ................. }
procedure f03; { p2 -> p3: }
var i,j: integer;
begin
   if al<= 1.000570 then
   ga := 1 - al - 2*be;
   for i:= 0 to mx-1 do
   for j:= 0 to my-1 do
   p3[i,j]:=p2[i div 2,j div 2];  {  - }

   for i:= 1 to mx2-2 do
   for j:= 1 to my2-2 do begin
     p3[2*i  ,2*j  ]:= round(al*p2[i,j] + be*p2[i-1,j] + be*p2[i,j-1] + ga*p2[i-1,j-1]);
     p3[2*i+1,2*j  ]:= round(al*p2[i,j] + be*p2[i+1,j] + be*p2[i,j-1] + ga*p2[i+1,j-1]);
     p3[2*i  ,2*j+1]:= round(al*p2[i,j] + be*p2[i-1,j] + be*p2[i,j+1] + ga*p2[i-1,j+1]);
     p3[2*i+1,2*j+1]:= round(al*p2[i,j] + be*p2[i+1,j] + be*p2[i,j+1] + ga*p2[i+1,j+1]);
   end;
end;
{----------------------------------------------------------------------}
function f_tst( f:TInterp ):extended;     {    }
var i,j: integer;
    summa,otkl:extended;
begin
   {   : p1 -> p2 }
   for i:= 0 to mx2-1 do
   for j:= 0 to my2-1 do
   p2[i,j]:=(integer(p1[2*i,2*j])+p1[2*i,  2*j+1]+
             p1[2*i+1,2*j]+p1[2*i+1,2*j+1] ) div 4;
   {   : p2 -> p3 }
   f;
   {   (p1-p3)    }
   summa:=0;
   for i:=1 to mx-2 do
   for j:=1 to my-2 do
   summa:=summa+sqr(p1[i,j]-p3[i,j]);
   otkl :=sqrt(summa/((mx-2)*(my-2)));
   f_tst := otkl;
end;
{----------------------------------------------------------------------}
procedure i_kind( fname: string ); {     }
var i,j: integer;
    cl : TColor;
    ext: string[5];
begin
   ext := UpperCase( ExtractFileExt(fname));
   if (ext <> '.BMP') and (ext <> '.JPG') and (ext <> '.JPEG') then Exit;
   for i:=1 to NFormul do res[i] := -1;
   try
     if UpperCase( ExtractFileExt(fname))= '.BMP' then
       BitMap.LoadFromFile(fname)
     else begin
       jp.LoadFromFile(fname);
       BitMap.Assign(jp);
     end;
     my:=Bitmap.Height;  if odd(my) then dec(my);
     mx:=Bitmap.Width;   if odd(mx) then dec(mx);
     my2 := my div 2;
     mx2 := mx div 2;

     SetLength( p1, mx+1,  my+1 );
     SetLength( p2, mx2+1, my2+1 );
     SetLength( p3, mx+1,  my+1 );
     {     : Bitmap -> p1 }
     for i:= 0 to mx-1 do
     for j:= 0 to my-1 do begin
       cl := Bitmap.Canvas.Pixels[i,j];
       p1[i,j] :=(integer(Lo(cl)) + Lo(cl shr 8) + Lo(cl shr 16)) div 3;
     end;
     res[ 1] := f_tst(f01);
     res[ 2] := f_tst(f02);
     al:= 0.25; be:= 0.25 ;    res[ 3] := f_tst(f03);
     al:= 9/16; be:= 3/16 ;    res[ 4] := f_tst(f03);
     al:=45/64; be:= (1-al)/2; res[ 5] := f_tst(f03);
     al:=38/64; be:= (1-al)/2; res[ 6] := f_tst(f03);
     al:=1.000580; be:=0.001033; ga:=0.001020;res[7]:=f_tst(f03);
   except
     on EFOpenError do p1:=nil;
   end;
   {  : }
   p1 := nil; p2 := nil; p3 := nil;
   {  }
   for i:=2 to NFormul do res[i] := res[i]/res[1];
end;
{----------------------------------------------------------------------}
var sr: TSearchRec;
    i, cou : integer;
    f : Text;
    ext: string[5];
begin
  BitMap := TBitMap.Create;
  jp := TJpegImage.Create;

  al := 1; be:=0; ga := 0;
  for i:=1 to NFormul do begin resS[i]:=0; resS2[i]:=0; end;
  if ParamCount = 0 then Assign( f, 'result.txt')
  else                   Assign( f, ParamStr(1));
  Rewrite(f);
  cou:=0;
  if FindFirst('*.*', faAnyFile, sr) = 0 then
  repeat
    ext := UpperCase( ExtractFileExt(sr.Name));
    if (ext <> '.BMP') and (ext <> '.JPG') and (ext <> '.JPEG') then continue;
    i_kind( sr.Name );
    inc(cou);
    for i:=1 to NFormul do begin
      resS [i]:=resS [i]+res[i];
      resS2[i]:=resS2[i]+Sqr(res[i]);
    end;
    Write( sr.Name:12,':');
    Write( f, sr.Name:20,':');
    for i:=1 to NFormul do begin
      Write( res[i]:6:3 );
      Write( f, res[i]:7:3 );
    end;
    WriteLn;
    WriteLn(f);

    Flush(f);
    {WriteLn('AllocMemSize=', AllocMemSize);}
  until FindNext(sr) <> 0;

  {  -   }
  Write( f, '':21);
  for i:=1 to NFormul do Write( f, i:7 );
  WriteLn(f);

  Write( f, 'M':20,':');
  for i:=1 to NFormul do Write( f, resS[i]/cou:7:3 );
  WriteLn(f);

  {  -   }
  Write( f, 's':20,':');
  for i:=1 to NFormul do Write( f, Sqrt((resS2[i] - Sqr(resS[i])/cou)/(cou-1)):7:3 );
  WriteLn(f);
  {ReadLn;}
  Close(f);
  Bitmap.Free;
end.




