program gr_h02; {        }
{$APPTYPE    CONSOLE}
uses
  Graphics, Classes, SysUtils, jpeg;  
const NFormul = 16; { #   }
      NN      = 8;  {   . }
type
  TInterp = procedure;  { p2 -> p3 }
var mx, my, mx2, my2: integer;
    BitMap : TBitMap;
    jp     : TJpegImage;
    p1, p2, p3: array of array of byte;
    res, resS, resS2 : array[1..NFormul] of extended;
    al, be, ga: extended;
{----------------------------------------------------------------------}
procedure f01; { p2 -> p3:     4   }
var i,j: integer;
begin
   for i:= 0 to mx-1 do
   for j:= 0 to my-1 do
   p3[i,j]:=p2[i div 2,j div 2];
end;
{ ................. }
procedure f02; { p2 -> p3:    }
var i,j: integer;
begin
   for i:= 0 to mx2-1 do
   for j:= 0 to my2-1 do begin
     p3[2*i  ,2*j  ]:=p2[i,j];
     p3[2*i+1,2*j  ]:=(integer(p2[i,j])+ p2[i+1,j]) div 2 ;
     p3[2*i  ,2*j+1]:=(integer(p2[i,j])+ p2[i,j+1]) div 2 ;
     p3[2*i+1,2*j+1]:=(integer(p2[i,j])+ p2[i+1,j]+ p2[i,j+1]+ p2[i+1,j+1]) div 4 ;
   end;
end;
{ ................. }
procedure f03; { p2 -> p3: }
var i,j: integer;
begin
   ga := 1 - al - 2*be;
   for i:= 0 to mx-1 do
   for j:= 0 to my-1 do
   p3[i,j]:=p2[i div 2,j div 2];  {  - }

   for i:= 1 to mx2-2 do
   for j:= 1 to my2-2 do begin
     p3[2*i  ,2*j  ]:= round(al*p2[i,j] + be*p2[i-1,j] + be*p2[i,j-1] + ga*p2[i-1,j-1]);
     p3[2*i+1,2*j  ]:= round(al*p2[i,j] + be*p2[i+1,j] + be*p2[i,j-1] + ga*p2[i+1,j-1]);
     p3[2*i  ,2*j+1]:= round(al*p2[i,j] + be*p2[i-1,j] + be*p2[i,j+1] + ga*p2[i-1,j+1]);
     p3[2*i+1,2*j+1]:= round(al*p2[i,j] + be*p2[i+1,j] + be*p2[i,j+1] + ga*p2[i+1,j+1]);
   end;
end;
{----------------------------------------------------------------------}
function f_tst( f:TInterp ):extended;     {    }
var i,j: integer;
    summa,otkl:extended;
begin
   {   : p1 -> p2 }
   for i:= 0 to mx2-1 do
   for j:= 0 to my2-1 do
   p2[i,j]:=(integer(p1[2*i,2*j])+p1[2*i,  2*j+1]+
             p1[2*i+1,2*j]+p1[2*i+1,2*j+1] ) div 4;
   {   : p2 -> p3 }
   f;
   {   (p1-p3)    }
   summa:=0;
   for i:=1 to mx-2 do
   for j:=1 to my-2 do
   summa:=summa+sqr(p1[i,j]-p3[i,j]);
   otkl :=sqrt(summa/((mx-2)*(my-2)));
   f_tst := otkl;
end;
{----------------------------------------------------------------------}
procedure i_kind( fname: string ); {     }
var i,j: integer;
    cl : TColor;
    ext: string[5];
    r00, r10, r01, r20, r11, r02, deno: extended;
begin
   ext := UpperCase( ExtractFileExt(fname));
   if (ext <> '.BMP') and (ext <> '.JPG') and (ext <> '.JPEG') then Exit;
   for i:=1 to NFormul do res[i] := -1;
   try
     if UpperCase( ExtractFileExt(fname))= '.BMP' then
       BitMap.LoadFromFile(fname)
     else begin
       jp.LoadFromFile(fname);
       BitMap.Assign(jp);
     end;
     my:=Bitmap.Height;  if odd(my) then dec(my);
     mx:=Bitmap.Width;   if odd(mx) then dec(mx);
     my2 := my div 2;
     mx2 := mx div 2;

     SetLength( p1, mx+1,  my+1 );
     SetLength( p2, mx2+1, my2+1 );
     SetLength( p3, mx+1,  my+1 );
     {     : Bitmap -> p1 }

     for i:= 0 to mx-1 do
     for j:= 0 to my-1 do begin
       cl := Bitmap.Canvas.Pixels[i,j];
       p1[i,j] :=(Lo(cl) + Lo(cl shr 8) + Lo(cl shr 16)) div 3;
     end;
     res[ 1] := f_tst(f01);      { :   }
     res[ 2] := f_tst(f02);      {     }
     al:=9/16; be:= 3/16 ; res[ 3] := f_tst(f03);  {   }
     al:=0;    be:=0;    r00:=f_tst(f03);
     al:=1/NN; be:=0;    r10:=f_tst(f03);
     al:=0;    be:=1/NN; r01:=f_tst(f03);
     al:=2/NN; be:=0;    r20:=f_tst(f03);
     al:=0;    be:=2/NN; r02:=f_tst(f03);
     al:=1/NN; be:=1/NN; r11:=f_tst(f03);
     deno := -4*r11*r00+4*r01*r10+4*r01*r11+4*r11*r10+2*r00*r20-4*r01*r20-4*r02*r10+2*r02*r20+2*r02*r00-2*r01*r01-2*r11*r11-2*r10*r10;
     al   := (2*r00*r20+4*r02*r00+2*r01*r00-2*r00*r10-6*r11*r00+8*r01*r10+2*r02*r20+8*r01*r11-2*r02*r11-6*r02*r10-4*r01*r20-8*r01*r01+2*r02*r01)/2/deno/NN;
     be   := (4*r00*r20+2*r00*r10-2*r01*r00+8*r01*r10-6*r01*r20-6*r11*r00+8*r11*r10-2*r11*r20-8*r10*r10+2*r10*r20-4*r02*r10+2*r02*r20+2*r02*r00)/2/deno/NN;
                           res[ 4] := f_tst(f03);  {   }
     WriteLn( 'Optim: c00=', r00:10:4,
                   '; c10=', NN*(-3/2*r00+2*r10-1/2*r20):10:4,
                   '; c01=', NN*(-3/2*r00+2*r01-1/2*r02):10:4,
                   '; c20=', Sqr(NN)*(1/2*r00-r10+1/2*r20):10:4,
                   '; c11=', Sqr(NN)*(1/2*r00-1/2*r10-1/2*r01+1/2*r11):10:4,
                   '; c02=', Sqr(NN)*(1/2*r00-r01+1/2*r02):10:4 );
     WriteLn( 'Optim: al=', al:10:4, '; be=', be:10:4,
              '; res=', res[4]:10:3, ' of ', res[1]:10:3);

     al:=0.90; be:= 0.00 ; res[ 5] := f_tst(f03);
     al:=0.90; be:= 0.025; res[ 6] := f_tst(f03);
     al:=0.90; be:= 0.05 ; res[ 7] := f_tst(f03);
     al:=0.80; be:= 0.00 ; res[ 8] := f_tst(f03);
     al:=0.80; be:= 0.05 ; res[ 9] := f_tst(f03);
     al:=0.80; be:= 0.10 ; res[10] := f_tst(f03);
     al:=0.70; be:= 0.00 ; res[11] := f_tst(f03);
     al:=0.70; be:= 0.075; res[12] := f_tst(f03);
     al:=0.70; be:= 0.15 ; res[13] := f_tst(f03);
     al:=0.60; be:= 0.00 ; res[14] := f_tst(f03);
     al:=0.60; be:= 0.10 ; res[15] := f_tst(f03);
     al:=0.60; be:= 0.20 ; res[16] := f_tst(f03);
   except
     on EFOpenError do p1:=nil;
   end;
   {  : }
   p1 := nil; p2 := nil; p3 := nil;
   {  }
   for i:=2 to NFormul do res[i] := res[i]/res[1];
end;
{----------------------------------------------------------------------}
var sr: TSearchRec;
    i, cou : integer;
    f : Text;
    ext: string[5];
begin
  BitMap := TBitMap.Create;
  jp := TJpegImage.Create;

  al := 1; be:=0; ga := 0;
  for i:=1 to NFormul do begin resS[i]:=0; resS2[i]:=0; end;
  if ParamCount = 0 then Assign( f, 'result.txt')
  else                   Assign( f, ParamStr(1));
  Rewrite(f);
  cou:=0;
  if FindFirst('*.*', faAnyFile, sr) = 0 then
  repeat
    ext := UpperCase( ExtractFileExt(sr.Name));
    if (ext <> '.BMP') and (ext <> '.JPG') and (ext <> '.JPEG') then continue;
    i_kind( sr.Name );
    inc(cou);
    for i:=1 to NFormul do begin
      resS [i]:=resS [i]+res[i];
      resS2[i]:=resS2[i]+Sqr(res[i]);
    end;
    Write( sr.Name:12,':');
    Write( f, sr.Name:20,':');
    for i:=1 to NFormul do begin
      Write( res[i]:6:2 );
      Write( f, res[i]:7:2 );
    end;
    WriteLn;
    WriteLn(f);

    Flush(f);
    {WriteLn('AllocMemSize=', AllocMemSize);}
  until FindNext(sr) <> 0;

  {  -   }
  Write( f, '':21);
  for i:=1 to NFormul do Write( f, i:7 );
  WriteLn(f);

  Write( f, 'M':20,':');
  for i:=1 to NFormul do Write( f, resS[i]/cou:7:2 );
  WriteLn(f);

  {  -   }
  if cou>1 then begin
    Write( f, 's':20,': ');
    for i:=1 to NFormul do Write( f, Sqrt((resS2[i] - Sqr(resS[i])/cou)/(cou-1)):7:3 );
    WriteLn(f);
  end;
  Close(f);
  Bitmap.Free;
  ReadLn;
end.




