program gr_h03; {   alpha, beta }
{$APPTYPE    CONSOLE}
uses
  Graphics, Classes, SysUtils, jpeg;
const NFormul = 16; { #   }
      NN      = 8;  {   . }
type
  TInterp = procedure;  { p2 -> p3 }
var mx, my, mx2, my2: integer;
    BitMap : TBitMap;
    jp     : TJpegImage;
    p1, p2, p3: array of array of byte;
    res, rmin: extended;
    al, be, ga: extended;
    f : Text;
{----------------------------------------------------------------------}
procedure f01; { p2 -> p3:     4   }
var i,j: integer;
begin
   for i:= 0 to mx-1 do
   for j:= 0 to my-1 do
   p3[i,j]:=p2[i div 2,j div 2];
end;
{ ................. }
procedure f02; { p2 -> p3:    }
var i,j: integer;
begin
   for i:= 0 to mx2-1 do
   for j:= 0 to my2-1 do begin
     p3[2*i  ,2*j  ]:=p2[i,j];
     p3[2*i+1,2*j  ]:=(integer(p2[i,j])+ p2[i+1,j]) div 2 ;
     p3[2*i  ,2*j+1]:=(integer(p2[i,j])+ p2[i,j+1]) div 2 ;
     p3[2*i+1,2*j+1]:=(integer(p2[i,j])+ p2[i+1,j]+ p2[i,j+1]+ p2[i+1,j+1]) div 4 ;
   end;
end;
{ ................. }
procedure f03; { p2 -> p3: }
var i,j: integer;
begin
   ga := 1 - al - 2*be;
   for i:= 0 to mx-1 do
   for j:= 0 to my-1 do
   p3[i,j]:=p2[i div 2,j div 2];  {  - }

   for i:= 1 to mx2-2 do
   for j:= 1 to my2-2 do begin
     p3[2*i  ,2*j  ]:= round(al*p2[i,j] + be*p2[i-1,j] + be*p2[i,j-1] + ga*p2[i-1,j-1]);
     p3[2*i+1,2*j  ]:= round(al*p2[i,j] + be*p2[i+1,j] + be*p2[i,j-1] + ga*p2[i+1,j-1]);
     p3[2*i  ,2*j+1]:= round(al*p2[i,j] + be*p2[i-1,j] + be*p2[i,j+1] + ga*p2[i-1,j+1]);
     p3[2*i+1,2*j+1]:= round(al*p2[i,j] + be*p2[i+1,j] + be*p2[i,j+1] + ga*p2[i+1,j+1]);
   end;
end;
{----------------------------------------------------------------------}
function f_tst( f:TInterp ):extended;     {    }
var i,j: integer;
    summa,otkl:extended;
begin
   {   : p1 -> p2 }
   for i:= 0 to mx2-1 do
   for j:= 0 to my2-1 do
   p2[i,j]:=(integer(p1[2*i,2*j])+p1[2*i,  2*j+1]+
             p1[2*i+1,2*j]+p1[2*i+1,2*j+1] ) div 4;
   {   : p2 -> p3 }
   f;
   {   (p1-p3)    }
   summa:=0;
   for i:=1 to mx-2 do
   for j:=1 to my-2 do
   summa:=summa+sqr(p1[i,j]-p3[i,j]);
   otkl :=sqrt(summa/((mx-2)*(my-2)));
   f_tst := otkl;
end;
{----------------------------------------------------------------------}
procedure i_kind( fname: string ); {     }
var i,j: integer;
    cl : TColor;
    ext: string[5];
begin
   ext := UpperCase( ExtractFileExt(fname));
   if (ext <> '.BMP') and (ext <> '.JPG') and (ext <> '.JPEG') then Exit;
   try
     if UpperCase( ExtractFileExt(fname))= '.BMP' then
       BitMap.LoadFromFile(fname)
     else begin
       jp.LoadFromFile(fname);
       BitMap.Assign(jp);
     end;
     my:=Bitmap.Height;  if odd(my) then dec(my);
     mx:=Bitmap.Width;   if odd(mx) then dec(mx);
     my2 := my div 2;
     mx2 := mx div 2;

     SetLength( p1, mx+1,  my+1 );
     SetLength( p2, mx2+1, my2+1 );
     SetLength( p3, mx+1,  my+1 );
     {     : Bitmap -> p1 }

     for i:= 0 to mx-1 do
     for j:= 0 to my-1 do begin
       cl := Bitmap.Canvas.Pixels[i,j];
       p1[i,j] :=(Lo(cl) + Lo(cl shr 8) + Lo(cl shr 16)) div 3;
     end;
     al := 0;
     repeat
       be := 0;
       Write( f, 'al=', al:7:3, ':');
       Write(    'al=', al:7:3, ':');
       rmin := 9999;
       repeat
         res := f_tst(f03);
         Write( f, res:8:3);
         Write(    res:8:3);
         be := be + 0.02;
         if res<rmin then rmin :=res;
       until al+2*be >= 1;
       WriteLn(f, '>', rmin:8:3 );
       WriteLn(    '>', rmin:8:3);
       al := al + 0.02;
     until al >= 1;
   except
     on EFOpenError do p1:=nil;
   end;
   {  : }
   p1 := nil; p2 := nil; p3 := nil;
   {  }
end;
{----------------------------------------------------------------------}
begin
  BitMap := TBitMap.Create;
  jp := TJpegImage.Create;

  al := 1; be:=0; ga := 0;
  Assign( f, 'result.txt');
  Rewrite(f);
  i_kind( ParamStr(1) );
  Close(f);
  Bitmap.Free;
  ReadLn;
end.




